import { UrlStateRouter } from './router';
import { DefaultSchema, UrlState, UrlStateMethods, UrlStateOptions, UrlStateValue } from './types';
export type { DefaultSchema, UrlState } from './types';
/**
 * Creates a hook that will manage the state of the URL search params.
 * @param {z.ZodObject} schema - zod schema to verify the url state
 * @param {Object} [initialValue] - initial value of the state
 * @param {UrlStateOptions} [options]
 * @param {boolean} [options.applyInitialValue] - if true, the initial value will be applied to the URL
 */
export declare function useUrlState<T extends DefaultSchema>(schema: T, initialValue?: UrlStateValue<T> | null, options?: UrlStateOptions): UrlState<T> & UrlStateMethods<T>;
export declare function useUrlStateWithRouter<T extends DefaultSchema>(schema: T, initialValue: UrlStateValue<T> | null, options: UrlStateOptions & {
    router: UrlStateRouter;
}): UrlState<T> & UrlStateMethods<T>;
