export type Callback = (newSearchParams: string) => void;
declare global {
    interface Window {
        next?: {
            router?: {
                push: (href: string) => void;
            };
        };
    }
}
export interface UrlStateRouter {
    push(href: string): void;
    subscribe(fn: Callback): void;
    unsubscribe(fn: Callback): void;
}
export type GenericRouterOptions = {
    poolingIntervalMs?: number;
};
export declare class GenericRouter implements UrlStateRouter {
    private options;
    private interval;
    private subscribers;
    constructor(options: GenericRouterOptions);
    push(href: string): void;
    subscribe(fn: Callback): void;
    unsubscribe(fn: Callback): void;
    onSearchParamsChange(): void;
    private startPolling;
    private stopPolling;
}
export declare function getGenericRouter(): GenericRouter;
